#include <conio.h>
#include <string.h>
#include "utils.h"
#include "menu.h"
#include "video.h"
#include "defs.h"
#include "kb.h"
#include "clock.h"
#include "dump.h"

class TMemdump {
  private:
    int edit;
    TMenu *menu;
    TDump *dump;
  public:
    TMemdump(char *);
    ~TMemdump();
    void DrawScreen();
    void RestoreScreen();
    void Run();
    void About();
    int Exit();
};

TMemdump::TMemdump(char *filename)
{
  DrawScreen();
  menu = new TMenu(0,
    NewMenuItem("File",
      NewSubMenuItem("Save to file    F2", 2,
      NewSubMenuItem("Go to address   F5", 3,
      NewSubMenuItem("Search string   F7", 4,
      NewSubMenuItem("Search again    F8", 7,
      NewSubMenuItem("Quit            Alt-X", 1, 0))))),
    NewMenuItem("Options",
      NewSubMenuItem("Toggle grid     F6", 6, 0),
    NewMenuItem("Help",
      NewSubMenuItem("About", 5, 0), 0))));
  dump = new TDump();
  edit = 1;
  ShowCursor();
}

TMemdump::~TMemdump()
{
  RestoreScreen();
  delete dump;
}

void TMemdump::DrawScreen()
{
  fill(0, 3, 80, 21, '', BACK_COLOR);
  fill(0, 24, 80, 1, ' ', MENU_COLOR);
  fill(0, 0, 80, 1, ' ', MENU_COLOR);
  out_hotstring(1, 24, "~F10~ Menu  ~Alt-X~ Quit ", MENU_COLOR, HOT_COLOR);
}

void TMemdump::RestoreScreen()
{
  gotoxy(1, 1);
  fill(0, 0, 80, 25, ' ', 0x07);
}

void TMemdump::Run()
{
  char key, old_key, filename[15] = "memory.dat", addr[6] = "00000";
  char s[60] = "";
  int command = 0, i;
  long pos = 0;
  About();

  ClearBuf();

  do
  {
    command = 0;

    if (kbhit())
    {
      key = getch();

      if (old_key == 0)
      switch (key)
      {
        case 68: HideCursor();
                 command = menu -> Run();
                 if (edit)
                   ShowCursor();
                 break;
        case 45: command = 1; break;
        case 60: command = 2; break;
        case 63: command = 3; break;
        case 64: command = 6; break;
        case 65: command = 4; break;
        case 66: command = 7; break;
        case 59: command = 5; break;
      }

      switch (command)
      {
        case 1: command = Exit(); break;
        case 2: if (!InputBox("Save", "Enter file name:", 13, filename, filename, 0, 34))
                dump -> Save(filename); break;
        case 3: if (!InputHexBox("Go to address", "Enter address:", 6, addr, addr, 0))
                dump -> GoTo(addr); break;
        case 4: if (dump -> GetPosition() == pos)
                {
                  if (!InputBox("Search string", "Enter string:", 60, s, s, 0, 60))
                    pos = dump -> Search(s, strlen(s)); break;
                }
                else
                {
                  if (!InputBox("Search string", "Enter string:", 60, s, s, 0, 60))
                    pos = dump -> Search(s, 0); break;
                }
        case 7: if (dump -> GetPosition() == pos)
                  pos = dump -> Search(s, strlen(s));
                else
                  pos = dump -> Search(s, 0);
                break;
        case 5: About(); break;
        case 6: dump -> ToggleGrid(); break;
      }

      if (edit) dump -> HandleEvent(key, old_key);
    }

    UpdateClock();
    dump -> Update();
    old_key = key;

  } while (command != 1);
}

void TMemdump::About()
{
  MessageBox("About", "System memory viewer/editor\nVersion 1.0\nCopyright (c) 1999 by HackMaster\nE-mail: hackmaster@mtu-net.ru\nInternet: http:\x2F\x2Fgo.to/hackmaster\n", 0);
}

int TMemdump::Exit()
{
  return !MessageBox("Memdump", "Do you really\nwant to quit?\n", 1);
}

void main(int argc, char *argv[])
{
  TMemdump *t;

  if (argc > 1)
    t = new TMemdump(argv[1]);
  else
    t = new TMemdump("");

  t -> Run();
  delete t;
}
